/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES 
**                                                 OR EXPLICITLY MARKED SECTIONS
**
**     Project   : ElBug
**     Processor : MC9S08QG4CDT
**     Version   : Bean 01.256, Driver 01.04, CPU db: 2.87.118
**     Datasheet : MC9S08QG8 Rev. 2 6/2006
**     Date/Time : 7.9.2008, 20:13
**     Abstract  :
**         This module contains device initialization code 
**         for selected on-chip peripherals.
**     Contents  :
**         Function "MCU_init" initializes selected peripherals
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################
*/

/* MODULE MCUinit */

#include <MC9S08QG4.h>                 /* I/O map for MC9S08QG4CDT */
#include "MCUinit.h"
#include "ElBug.h"

/* User declarations and definitions */
/*   Code, declarations and definitions here will be preserved during code generation */
/* End of user declarations and definitions */


/*
** ===================================================================
**     Method      :  MCU_init (bean MC9S08QG4_16)
**
**     Description :
**         Device initialization code for selected peripherals.
** ===================================================================
*/
void MCU_init(void)
{
  /* ### MC9S08QG4_16 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* Common initialization of the write once registers */
  /* SOPT1: COPE=0,COPT=1,STOPE=0,BKGDPE=1,RSTPE=0 */
  SOPT1 = 0x52;                                      
  /* SPMSC1: LVDF=0,LVDACK=0,LVDIE=0,LVDRE=1,LVDSE=1,LVDE=1,BGBE=0 */
  SPMSC1 = 0x1C;                                      
  /* SPMSC2: PDF=0,PPDF=0,PPDACK=0,PDC=0,PPDC=0 */
  SPMSC2 = 0x00;                                      
  /* SPMSC3: LVDV=0,LVWV=0 */
  SPMSC3 &= (unsigned char)~0x30;                     
  /*  System clock initialization */
  ICSTRM = *(unsigned char*far)0xFFAF; /* Initialize ICSTRM register from a non volatile memory */
  ICSSC = *(unsigned char*far)0xFFAE;  /* Initialize ICSSC register from a non volatile memory */
  /* ICSC1: CLKS=0,RDIV=0,IREFS=1,IRCLKEN=0,IREFSTEN=0 */
  ICSC1 = 0x04;                        /* Initialization of the ICS control register 1 */
  /* ICSC2: BDIV=0,RANGE=0,HGO=0,LP=0,EREFS=0,ERCLKEN=0,EREFSTEN=0 */
  ICSC2 = 0x00;                        /* Initialization of the ICS control register 2 */
  /* Common initialization of the CPU registers */
  /* PTAPE: PTAPE3=1,PTAPE2=1 */
  PTAPE |= (unsigned char)0x0C;                               
  /* PTASE: PTASE4=1,PTASE3=1,PTASE2=1,PTASE1=0,PTASE0=1 */
  PTASE = (PTASE & (unsigned char)~0x02) | (unsigned char)0x1D;
  /* PTBSE: PTBSE7=1,PTBSE6=1,PTBSE5=1,PTBSE4=1,PTBSE3=1,PTBSE2=1,PTBSE1=1,PTBSE0=1 */
  PTBSE = 0xFF;                                      
  /* PTADS: PTADS5=0,PTADS4=0,PTADS3=0,PTADS2=0,PTADS1=1,PTADS0=1 */
  PTADS = 0x03;                                      
  /* PTBDS: PTBDS7=0,PTBDS6=0,PTBDS5=0,PTBDS4=0,PTBDS3=0,PTBDS2=0,PTBDS1=0,PTBDS0=0 */
  PTBDS = 0x00;                                      
  /* ### Init_KBI init code */
  /* KBISC: KBIE=0 */
  KBISC &= (unsigned char)~0x02;                     
  /* KBIES: KBEDG7=0,KBEDG6=0,KBEDG5=0,KBEDG4=0,KBEDG3=0,KBEDG2=0,KBEDG1=0,KBEDG0=0 */
  KBIES = 0x00;                                      
  /* KBISC: KBIMOD=1 */
  KBISC |= (unsigned char)0x01;                               
  /* KBIPE: KBIPE7=0,KBIPE6=0,KBIPE5=0,KBIPE4=0,KBIPE3=1,KBIPE2=1,KBIPE1=0,KBIPE0=0 */
  KBIPE = 0x0C;                                      
  /* KBISC: KBACK=1 */
  KBISC |= (unsigned char)0x04;                               
  /* KBISC: KBIE=1 */
  KBISC |= (unsigned char)0x02;                               
  /* ### Init_GPIO init code */
  /* PTAD: PTAD1=1,PTAD0=0 */
  PTAD = (PTAD & (unsigned char)~0x01) | (unsigned char)0x02;
  /* PTAPE: PTAPE5=1,PTAPE1=1 */
  PTAPE |= (unsigned char)0x22;                               
  /* PTADD: PTADD1=1,PTADD0=1 */
  PTADD |= (unsigned char)0x03;
  PTBDD |= (unsigned char)0xFC; //nevyveden pady ipu na vnj piny pouzdra                              
  /* ### Init_RTI init code */
  /* SRTISC: RTIF=0,RTIACK=1,RTICLKS=0,RTIE=1,RTIS2=0,RTIS1=0,RTIS0=1 */
  SRTISC = 0x51;                                      
  /* ### Init_SCI init code */
  /* SCIC2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=0,RE=0,RWU=0,SBK=0 */
  SCIC2 = 0x00;                        /* Disable the SCI module */
  (void)(SCIS1 == 0);                  /* Dummy read of the SCIS1 registr to clear flags */
  (void)(SCID == 0);                   /* Dummy read of the SCID registr to clear flags */
  /* SCIS2: BRK13=0,RAF=0 */
  SCIS2 = 0x00;                                      
  /* SCIBDH: SBR12=0,SBR11=0,SBR10=0,SBR9=0,SBR8=0 */
  SCIBDH = 0x00;                                      
  /* SCIBDL: SBR7=0,SBR6=0,SBR5=1,SBR4=1,SBR3=0,SBR2=1,SBR1=0,SBR0=0 */
  SCIBDL = 0x34;                                      
  /* SCIC1: LOOPS=0,SCISWAI=0,RSRC=0,M=0,WAKE=0,ILT=0,PE=0,PT=0 */
  SCIC1 = 0x00;                                      
  /* SCIC2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=1,RE=1,RWU=0,SBK=0 */
  SCIC2 = 0x0C;                                      
  /* SCIC3: R8=0,T8=0,TXDIR=1,TXINV=0,ORIE=0,NEIE=0,FEIE=0,PEIE=0 */
  SCIC3 = 0x20;                                      
  /* ### */
  asm CLI;                             /* Enable interrupts */
} /*MCU_init*/


/*
** ===================================================================
**     Interrupt handler : isrVrti
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVrti(void)
{
  
  
 
  if (Timeout>0) Timeout--; 
  if (ZpozdeniMezery>0) ZpozdeniMezery--;
 
  
  SRTISC_RTIACK=1;
}
/* end of isrVrti */


/*
** ===================================================================
**     Interrupt handler : isrVkeyboard
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVkeyboard(void)
{
unsigned char i;
  if ((Port&(Set))==0) 
                { Flag=4;goto nastaveni;}
   
   Wait(1); //ceka T*8ms  (debounce)
   Odeslano=0;
     
   if ((Port&(Iambic))==0) 
                {if (Flag==1) { HrajCarku(); goto exit;} 
                 if (Flag==2) { HrajTecku(); goto exit;}
                }
   if ((Port&(Tecka))==0)  
                { 
                 HrajTecku();
                 goto exit;
                }
   if ((Port&(Carka))==0)  
                { 
                 HrajCarku();
                 goto exit;
                }
 nastaveni:
    asm Nop;
    if ((Port&(Tecka))==0)  
                { 
                  i=0; do {Send(SET[i]); i++;} while ((SET[i])!=0);
                  
                  i=0; do {Send(UP[i]); i++;} while ((UP[i])!=0);
                  Send(10); Send(13);  //CR LF 
                  Send(' '); // je dummy write do SCI
                  Timing=(Timing--);
                  Wait(100);
                  goto exit;
                }
    if ((Port&(Carka))==0)  
                {  
                  i=0; do {Send(SET[i]);i++;} while ((SET[i])!=0); 
                   
                  i=0; do {Send(DWN[i]);i++;} while ((DWN[i])!=0);
                  Send(10); Send(13);  //CR LF 
                  Send(' '); // je dummy write do SCI
                  Timing=(Timing++);
                  Wait(100);
                }
 exit:
 /* KBISC: KBACK=1 */
  KBISC |= (unsigned char)0x04;
  asm Nop;
}
/* end of isrVkeyboard */


/*
** ===================================================================
**     Interrupt handler : isrVscitx
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVscitx(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVscitx */


/*
** ===================================================================
**     Interrupt handler : isrVscirx
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVscirx(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVscirx */


/*
** ===================================================================
**     Interrupt handler : isrVscierr
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVscierr(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVscierr */



/* Initialization of the CPU registers in FLASH */

/* NVPROT: FPS=0x7F,FPDIS=1 */
const unsigned char NVPROT_INIT @0x0000FFBD = 0xFF;

/* NVOPT: KEYEN=0,FNORED=1,SEC01=1,SEC00=0 */
const unsigned char NVOPT_INIT @0x0000FFBF = 0x7E;



extern near void _Startup(void);

/* Interrupt vector table */
#ifndef UNASSIGNED_ISR
  #define UNASSIGNED_ISR 0xFFFF        /* unassigned interrupt service routine */
#endif

void (* near const _vect[])() @0xFFD0 = { /* Interrupt vector table */
         isrVrti,                      /* Int.no. 23 Vrti (at FFD0)                  Used */
         UNASSIGNED_ISR,               /* Int.no. 22 Reserved2 (at FFD2)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 21 Reserved3 (at FFD4)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 20 Vacmp (at FFD6)                 Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 19 Vadc (at FFD8)                  Unassigned */
         isrVkeyboard,                 /* Int.no. 18 Vkeyboard (at FFDA)             Used */
         UNASSIGNED_ISR,               /* Int.no. 17 Viic (at FFDC)                  Unassigned */
         isrVscitx,                    /* Int.no. 16 Vscitx (at FFDE)                Used */
         isrVscirx,                    /* Int.no. 15 Vscirx (at FFE0)                Used */
         isrVscierr,                   /* Int.no. 14 Vscierr (at FFE2)               Used */
         UNASSIGNED_ISR,               /* Int.no. 13 Vspi (at FFE4)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 12 Vmtim (at FFE6)                 Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 11 Reserved13 (at FFE8)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 10 Reserved14 (at FFEA)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  9 Reserved15 (at FFEC)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  8 Reserved16 (at FFEE)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  7 Vtpmovf (at FFF0)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  6 Vtpmch1 (at FFF2)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  5 Vtpmch0 (at FFF4)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  4 Reserved20 (at FFF6)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  3 Vlvd (at FFF8)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  2 Virq (at FFFA)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  1 Vswi (at FFFC)                  Unassigned */
         _Startup                      /* Int.no.  0 Vreset (at FFFE)                Reset vector */
};





/* END MCUinit */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 3.01 [03.92]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
